// LayerView.h : CLayerView NX̃C^[tFCX
//


#pragma once

class CLayerView : public CView
{
protected: // VÂݍ쐬܂B
	CLayerView();
	DECLARE_DYNCREATE(CLayerView)

// 
public:
	CLayerDoc* GetDocument() const;

// 
public:

// I[o[Ch
	public:
	virtual void OnDraw(CDC* pDC);  // ̃r[`悷邽߂ɃI[o[Ch܂B
virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:

// 
public:
	virtual ~CLayerView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// ꂽAbZ[W蓖Ċ֐
protected:
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnFileOpen();
	afx_msg void OnFileSaveAs();
	afx_msg void OnViewShading();
	afx_msg void OnViewAlbedo();
	afx_msg void OnViewZenith();
	afx_msg void OnViewAzimuth();
	afx_msg void OnViewNeedle();
	afx_msg void OnViewColor();
	afx_msg void OnViewAlbedonew();
	afx_msg void OnViewZenithnew();
	afx_msg void OnViewAzimuthnew();
	afx_msg void OnViewNeedlenew();
	afx_msg void OnViewRender();
	afx_msg void OnUpdateViewColor(CCmdUI *pCmdUI);
	afx_msg void OnCalcCalc();
	afx_msg void OnCalcIterate();
	afx_msg void OnOptionOption();
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnUpdateIndicatorMiya(CCmdUI *pCmdUI);
	virtual void OnInitialUpdate();
	void UpdateMiyaStatusbar(void);
	void CheckView(int miyamenu);
	void ReadData(CString filename, int id);
	void ReadLight(CString filename, int id);
	void WriteImage(CString filename);
	void WriteData(CString filename, int filemode);
	void CreateImages(void);
	void CreateNeedleImage(int filemode);
	void CreateRenderImage();
	inline double shading(int i, double nx, double ny, double nz);
	double Median(double* x, int n, double RANGEMIN, double RANGEMAX);
	double neighbor(double*** data, int x, int y, int a);
	double PI;
	double EPS;
	double INF;
	int INTINF;
	int MENUVIEW;
	int COLR;
	int COLG;
	int COLB;
	int AXISX;
	int AXISY;
	int AXISZ;
	int WIDTH;
	int HEIGHT;
	int IMAGEMIN;
	int IMAGEMAX;
	int MIYA_SHADING;
	int MIYA_ALBEDO;
	int MIYA_ZENITH;
	int MIYA_AZIMUTH;
	int MIYA_NEEDLE;
	int MIYA_NORMAL;
	int MIYA_ALBEDONEW;
	int MIYA_ZENITHNEW;
	int MIYA_AZIMUTHNEW;
	int MIYA_NEEDLENEW;
	int MIYA_NORMALNEW;
	int MIYA_RENDER;
	int LOOPNUM;
	int maxmenu;
	int viewmode;
	int imageview;
	bool colormode;
	int imagenum;
	bool* processdone;
	int PROCESSMAX;
	CString sFileName;
	int ALBEDOMED;
	double ALBEDOAVG;
	int NORMALMED;
	double NORMALAVG;
	unsigned char* screendata;
	unsigned char**** shadingimage;
	unsigned char*** needleimage;
	double*** normal;
	double*** albedo;
	double*** normalnew;
	double*** albedonew;
	double** lightpos;
	unsigned char*** renderimage;
	inline double SQR(double x) {return x * x;}
	inline double NORM(double x, double y, double z) {return sqrt(SQR(x) + SQR(y) + SQR(z));}
	inline double DOTPRODUCT(double ax, double ay, double az, double bx, double by, double bz) {return ax * bx + ay * by + az * bz;}
	inline int COMBINATION3(int n) {return n * (n - 1) * (n - 2) / 6;}
};

#ifndef _DEBUG  // LayerView.cpp ̃fobO o[W
inline CLayerDoc* CLayerView::GetDocument() const
   { return reinterpret_cast<CLayerDoc*>(m_pDocument); }
#endif

